import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class roachAttack6 extends PApplet {/*

Roach Attack v3.5
Cadin Batrack 6/1/05

Kill those suckers!
Let them live too long and they'll start to breed.
Look for them hiding under objects.


*/

// I've tried to comment this pretty well
// If you have questions about what's going
// on feel free to ask
// .cadin.

//The total number of possible Roaches
int MAX = 36;
// The current number of Roaches
int MIN = 2;

//Declare Arrays of Roaches & Bombs
roach[] myRoaches = new roach[MAX];
bomb[] bombArray = new bomb[30];

// threw arrays that keep track of the position and rotation
// of the squished roaches to redraw their dead bodies
float[] squishX = new float[300];
float[] squishY = new float[300];
float[] squishRot = new float[300];

//likewise for roaches killed by other means
float[] sprayedX = new float[300];
float[] sprayedY = new float[300];
float[] sprayedRot = new float[300];

// timer used to keep the breed warning up
// for a given number of milliseconds
float warningTimer;

// three counters: count how many we've squished
// how many we've sprayed (or bombed) and the two
// combined equal the total dead
int squishCounter;
int sprayedCounter;
int deadCounter;

float breedTime = 9.5f;

// keeps track of the bombs in the bombArray
int bombCounter;

//spray can counters
int sprayCounter;
int sprayTimeout;

int level;

// win, lose, or intro?
boolean infestation;
boolean win;
boolean intro;
boolean quit;
boolean settings;

int slider1pos = 100;
int slider2pos = 100;

//font
PFont knockout = loadFont("Knockout-HTF52-Cruiserweight-12.vlw");
PFont knockout32 = loadFont("Knockout-HTF52-Cruiserweight-32.vlw");

//images
PImage introPic = loadImage("intro.jpg");
PImage settingsBG = loadImage("settings.jpg");
PImage thumb = loadImage("thumb.gif");
PImage squish = loadImage("squish.gif");
PImage squish_a = loadImage("squish_alpha.gif");
PImage dead = loadImage("deadroach.gif");
PImage dead_a = loadImage("dead_alpha.gif");
PImage bgPic = loadImage("background.jpg");
PImage spoon = loadImage("spoon.jpg");
PImage spoon_a = loadImage("spoon_alpha.gif");
PImage tea = loadImage("tea.jpg");
PImage tea_a = loadImage("tea_alpha.gif");
PImage breed = loadImage("breeding.gif");
PImage scoreBoard = loadImage("scoreboard.gif");
PImage spray = loadImage("spraycan.gif");
PImage spray_a = loadImage("spray_alpha.gif");
PImage raid_a = loadImage("raid_alpha.gif");
PImage raid = loadImage("raid.gif");
PImage bomb = loadImage("bomb.gif");
PImage bomb_a = loadImage("bomb_a.gif");
PImage bombset = loadImage("bombset.jpg");
PImage bombset_a = loadImage("bombset_a.gif");
PImage easyButton = loadImage("easyButton.jpg");
PImage medButton = loadImage("medButton.jpg");
PImage difButton = loadImage("difButton.jpg");
PImage gameOver = loadImage("gameOver.jpg");
PImage playAgainButton = loadImage("playAgainButton.jpg");
PImage playButton = loadImage("playButton.jpg");
PImage cancelButton = loadImage("cancelButton.jpg");
PImage customButton = loadImage("customButton.jpg");
PImage loseMessg = loadImage("loseMessg.jpg");
PImage quitMessg = loadImage("quitMessg.jpg");
PImage harderLevel = loadImage("harderLevel.jpg");
PImage easierLevel = loadImage("easierLevel.jpg");
PImage bombTiny = loadImage("bombTiny.gif");
PImage bombTiny_a = loadImage("bombTiny_a.gif");
PImage QtoQuit = loadImage("QtoQuit.gif");
PImage QtoQuit_a = loadImage("QtoQuit_a.gif");

boolean breeding;

boolean sprayCanActive;
boolean sprayCanPaused;
boolean bombingActive;
boolean cheatMode;

int moveDist = 50;
int moveSpeed;

//the roach timer (19 seconds)
int timerVar = 19000;

public void setup() {
  size(400,400);
  imageMode(CENTER);
  noStroke();
  framerate(25);
  
  //fill array of roaches
  for (int i = 0; i < MAX; i++) {
    myRoaches[i] = new roach();
  }

  //fill array of bombs
  for (int i = 0; i < 30; i++) {
    bombArray[i] = new bomb();
  }
  
  // set up the game
  resetGame();
  
  cheatMode=false;
  
} // ! end setup !


public void draw() {

  deadCounter = squishCounter + sprayedCounter;
   
  // is the intro inactive, and the game still in progress?
  if(!intro && !infestation && !win && !quit && !settings) {

    image(bgPic,200,184);
    drawDead();

    // for every Roach in the array move it and draw it
    for (int i = 0; i < MIN; i++) {
      push();
      float randomDist = random(10,moveDist);
      myRoaches[i].moveRoach(randomDist);
      myRoaches[i].drawRoach();
      pop();
    }

    // draw the objects for them to hide under
    alpha(spoon,spoon_a);
    image(spoon,373,175);
    alpha(tea,tea_a);
    image(tea,22,321);
    
    // draw quit key hint
    if(keyPressed) {
      if(key != 'q' && keyCode != SHIFT && keyCode != CONTROL) {
         fill(46,26,8,150);
         rect(0,0,400,20);
         fill(255, 200);
         textFont(knockout);
         textMode(ALIGN_CENTER);
         textSpace(SCREEN_SPACE);
         text("PRESS 'Q' TO QUIT", 200,13); 
         textSpace(OBJECT_SPACE);
      }
      
    }


    if (mousePressed) {

      // if the spraycan is active
      if(sprayCanActive) {
        
        //draw the spray
        fill(200,40);
        for(int i = 0; i<25; i++) {
          float rx = random(mouseX - 30, mouseX+30);
          float ry = random(mouseY - 30, mouseY+30);
          ellipse(rx,ry, 15,15);
          ellipse(rx,ry, 5,5);
        }
        
      //update the can counter
      sprayCounter = sprayTimeout - millis();
      
      }

      // the spraycan allows killing by dragging over roaches
      // hence this goes within mousePressed within the main loop
      // normal killing only happens on the single event click
      for (int i = 0; i < MIN; i++) {
        if(myRoaches[i].isOver(myRoaches[i].posX,myRoaches[i].posY) 
           && sprayCanActive && !myRoaches[i].isHiding) {
          poison(i);
        }
      }
    } // ! end mousePressed !


    //if the spraycan is active
    if(sprayCanActive) {

      alpha(raid, raid_a);
      image(raid, mouseX, mouseY+20);

      //draw the meter
      fill(255,0,0);
      rect(mouseX-13, (mouseY+44)-((sprayCounter/270)+1), 4, (sprayCounter/270)+1);
      stroke(100);
      line(mouseX-14, (mouseY+44)-((sprayCounter/270)+1), mouseX-8, (mouseY+44)-((sprayCounter/270)+1));
      noStroke();

      if(bombingActive) {
        //draw the tiny bomb
        
        alpha(bombTiny, bombTiny_a);
        image(bombTiny, mouseX+14, mouseY+38);
        
      }
      
      //the spraycan timeout
      if(sprayCounter < 1) {
        sprayCanActive = false;
        
      
      }
      
    } else if(bombingActive) {
      //the bomb that follows the mouse
      alpha(bomb, bomb_a);
      image(bomb, mouseX, mouseY);
    }

    // loop through array and update any active bombs
    for(int i=0; i < bombCounter; i++) {
      bombArray[i].updateBomb();
      bombArray[i].displayBomb();
    }

    //draw the scoreboard
    fill(213,210,206);
    image(scoreBoard, 200, 384);
    textFont(knockout32, 32);
    textMode(ALIGN_LEFT);
    text(deadCounter, 308.5f, 396);

    //draw the infestation meter
    for(int i = 0; i < MIN; i++) {
      //gradient color
      fill(i*12.5f,(255 - (i*6.5f)),0);
      rect(10 + (4*i),385, 3,11);
    }

    //flash the warning light
    if(breeding) {

      if((warningTimer) <  millis()) {
        breeding = false;
      } else {
        image(breed,183,390);
      }

    }
    
    //if the game was quit
  } else if(quit) {
    
    // bg images
    image(gameOver, 200,200);
    image(quitMessg, 204, 171);
    
    // draw the roach counter
    textFont(knockout32, 32);
    fill(242,231,210);
    textMode(ALIGN_CENTER);
    if(deadCounter == 1) {
      text(deadCounter + " ROACH", 198, 235);
    } else {
      text(deadCounter + " ROACHES", 198, 235);
    }
    
    
    // 'play again' button
    if(isOver(146,301,106,19)) {
      image(playAgainButton, 197, 310);
    }
   
   
    //if the game has been lost
  } else if(infestation) {
    
    // bg images
    image(gameOver, 200,200);
    image(loseMessg, 204, 171);
    
    // draw the roach counter
    textFont(knockout32, 32);
    fill(242,231,210);
    textMode(ALIGN_CENTER);
    if(deadCounter == 1) {
      text(deadCounter + " ROACH", 198, 235);
    } else {
      text(deadCounter + " ROACHES", 198, 235);
    }
    
    // why not try an easier level? 
    // (unless it's the already the easiest level)
    if(level > 1) {
      image(easierLevel, 195, 275);
    }
    
    // 'play again' button
    if(isOver(146,301,106,19)) {
      image(playAgainButton, 197, 310);
    }
    
    
    // if the game has been won
  } else if(win) {
    
    // bg image
    image(gameOver, 200,200);
    
    // draw the roach counter
    textFont(knockout32, 32);
    fill(242,231,210);
    textMode(ALIGN_CENTER);
    text(deadCounter + " ROACHES", 196, 235);
    
    // why not try a harder level?
    // (unless it's already the hardest level)
    if(level < 3) {
      image(harderLevel, 195, 275);
    }
    
    // 'play again' button
    if(isOver(146,301,106,19)) {
      image(playAgainButton, 197, 310);
    }


    // if the intro is active
  } else if(intro) {
    image(introPic, 200, 200);
    
    // easy, medium, hard buttons
    if(isOver(69,300,68,20)) {
      image(easyButton,103,310);
    } else if (isOver(144,300,81,20)) {
      image(medButton,184,310);
    } else if (isOver(232,300,81,20)) {
      image(difButton,272,310);
      
      //custom level button
    } else if (isOver(142, 335, 90,20)) {
      image(customButton, 188,345);
    }
  
  
  
    // if the settings are active
  } else if(settings) {
    image(settingsBG, 200, 200);
    
    //slider images
    image(thumb, slider1pos, 143);
    image(thumb, slider2pos, 221);
    
    //check boxes
    fill(255);
    if(cheatMode) {
      rect(70,290,6,3);
    } else {
      rect(70,305,6,3);
    }
    
    // cancel and play buttons
    if(isOver(269,344,67,20)) {
      image(playButton,302,353);
    } else if (isOver(199,344,67,20)) {
      image(cancelButton,232,353);
    }
    
    //slider operation
    if(mousePressed) {
      if(isOver(61,135,277,16)) {
        moveDist = PApplet.toInt((mouseX - 61)/3 + 30);
        slider1pos = mouseX;
    
      } else if(isOver(61,213,277,16)) {
        breedTime = PApplet.toInt(((mouseX - 61)/14)) +1;
        slider2pos = mouseX;
      }
      
    }
    
  }// ! end settings !
  
} // ! end voidDraw !


public void mouseReleased() {
  
  // when the mouse is released put the sprayCounter on
  // hold, so it only loses power when you're spraying it
  if(sprayCanActive) {
    sprayCounter = sprayTimeout - millis();
    sprayCanPaused = true;
  }
  
}

void drawDead() {

  //loop through the array to the extent of the squishCounter
  for(int i = 0; i < squishCounter; i++) {

    push();

    //draw the dead body
    translate(squishX[i],squishY[i]);
    rotate(squishRot[i] + degrees(90));
    alpha(squish,squish_a);
    image(squish,0,0);

    pop();

  }

  //loop through the array to the extent of the sprayedCounter
  for(int i = 0; i < sprayedCounter; i++) {

    push();

    //draw the dead body
    translate(sprayedX[i],sprayedY[i]);
    rotate(sprayedRot[i] + degrees(90));
    alpha(dead,dead_a);
    image(dead,0,0);

    pop();

  }

} // ! end void drawDead


void squish(int i) {

  //add the roach's coords to the squished arrays
  squishX[squishCounter] = myRoaches[i].posX;
  squishY[squishCounter] = myRoaches[i].posY;
  squishRot[squishCounter] = myRoaches[i].angle;
  // increment the squish counter
  squishCounter++;
  if (deadCounter > 200) {
    win = true;
  }

  resetRoach(i);
  checkSpecial(i);
}

// poisoning from spray or bombs
void poison(int i) {

  //add the roach's coords to the squished arrays
  sprayedX[sprayedCounter] = myRoaches[i].posX;
  sprayedY[sprayedCounter] = myRoaches[i].posY;
  sprayedRot[sprayedCounter] = myRoaches[i].angle;
  // increment the squish counter
  sprayedCounter++;
  if (deadCounter > 200) {
    win = true;
  }
  
  resetRoach(i);
  checkSpecial(i);
}


void resetRoach(int i) {

  // reset the roach to a new position (psuedo new roach)
  // randomly choose to spawn from under spoon or tea bag
  int randPos = PApplet.toInt(random(0,2));
  if (randPos == 0) {
    myRoaches[i].posX = 400;
    myRoaches[i].posY = 150;
  } else {
    myRoaches[i].posX = 10;
    myRoaches[i].posY = 320;
  }
  
  //reset timer
  myRoaches[i].roachTimer = millis()+timerVar;
  
  
 

}

// checks if mouse is over buttons
boolean isOver(int x, int y, int w, int h) {     

    if(mouseX > (x) && mouseX < (x+w) &&
    mouseY > (y) && mouseY < (y+h) ) {
      return(true);
    } else {
      return(false);
    }
}


void checkSpecial(int i) {
  
  //if the roach that got squished was special
  if (myRoaches[i].special == 1) {
    //turn on the spraycan
    sprayCanActive = true;
    sprayTimeout = millis() + 8000;
    sprayCounter = sprayTimeout - millis();
  } else if(myRoaches[i].special == 2) {
    //activate bomb
    bombingActive = true;
  }
  
  
  //special lil guy
  //every 5 kills
  if(deadCounter % 5 == 0 && !cheatMode && !sprayCanActive && !bombingActive && deadCounter > 0) {
    //make a special roach
    myRoaches[i].special = 1;

    //every 3 kills
  } else if (deadCounter % 3 == 0 &&!cheatMode && !bombingActive && deadCounter >0) {
    //make an extra special roach
    myRoaches[i].special = 2;

  } else {
    //normal roach
    myRoaches[i].special = 0;
  }
  
}


void resetGame() {
  
  //set all the variables to their starting positions
  quit=false;
  settings=false;
  intro=true;
  infestation = false;
  win = false;
  squishCounter = 0;
  sprayedCounter = 0;
  deadCounter = 0;
  bombingActive = false;
  sprayCanActive = false;
  sprayCanPaused = false;
  bombCounter = 0;
  breeding = false;
  

  // set all the roaches to starting positions
  for(int i=0;i < MIN; i++) {
    resetRoach(i);
  }
  
  MIN = 2;
  
}

// um, start the game
void startGame(int time) {
   timerVar=time;
   myRoaches[0].isActive = true;
   myRoaches[1].isActive = true;
   myRoaches[0].roachTimer = millis() + timerVar;
   myRoaches[1].roachTimer = millis() + timerVar;
   intro = false;
}

public void mousePressed() {
  
  
  if(sprayCanPaused) {
     // unpause the spraycan
     sprayTimeout = millis() + sprayCounter;
     sprayCanPaused = false;
  }

  if(intro) {
    // easy, medium, and hard buttons
    if(isOver(69,300,68,20)) {
      breedTime = 9.5f;
      startGame(PApplet.toInt(breedTime*2000));
      moveDist = 65;
      moveSpeed = 2;
      level = 1;
      cheatMode=false;
    } else if (isOver(144,300,81,20)) {
      breedTime = 5;
      startGame(PApplet.toInt(breedTime*2000));
      moveDist = 70;
      moveSpeed = 2;
      level = 2;
      cheatMode = false;
    } else if (isOver(232,300,81,20)) {
      breedTime = 2.5f;
      startGame(PApplet.toInt(breedTime*2000));
      moveDist = 80;
      moveSpeed = 2;
      level = 3;
      cheatMode = false;
      
      //custom level button
    } else if (isOver(142, 335, 95,20)) {
      settings = true;
      intro=false;
      moveSpeed = 2;
      level = 2;
      
      // set the slider positions
      slider1pos = PApplet.toInt((moveDist-30)*3) + 61;
      slider2pos = PApplet.toInt((breedTime -1)*14) +61; 
    }
    
    
  } else if(infestation || win || quit) {
    //if the game is over, reset 
    if(isOver(146,301,106,19)) {
      image(playAgainButton, 197, 310);
      resetGame();
    }
    
  } else if(settings){
    //play and cancel buttons
    if(isOver(269,344,67,20)) {
      image(playButton,302,353);
      settings=false;
      moveSpeed=2;
      startGame(PApplet.toInt(breedTime*2000));
    } else if (isOver(199,344,67,20)) {
      image(cancelButton,232,353);
      resetGame();
      
      //check boxes
    }  else if (isOver(65, 286,37,11)) {
      cheatMode=true;
    } else if(isOver(65, 300,37,11)) {
      cheatMode=false;
    }
    
  } // end of settings

  // Drop tha bomb!
  if(bombingActive && !sprayCanActive) {  
    bombArray[bombCounter].setBomb(mouseX, mouseY);
  }

  if(!settings && !win && !quit && !infestation && !intro){
  // Loop through roach array
  for(int i=0;i < MIN; i++) {
    //if the mouse is over the roach
    if(myRoaches[i].isOver(myRoaches[i].posX,myRoaches[i].posY) && !myRoaches[i].isHiding) {
      squish(i);
    }
  }
  }
} //end void mousePressed()


public void keyPressed() {
  
  // cheat mode
  if(cheatMode){
    if (keyCode == SHIFT) {
      bombingActive = true;
    }
    if (keyCode == CONTROL) {
      sprayCanActive = true;
      sprayCanPaused = true;
      sprayTimeout = millis() + 8000;
      sprayCounter = sprayTimeout - millis();
    }
  }
  
  //quit game
  if(key == 'q') {
    quit = true;
  }
  
  /*
  //for debugging
  if(key == 'w') {
    win = true;
  }  
  if (key == 'l') {
    infestation = true;
  }
  if(key == 's') {
    settings = true;
    intro = false;
  }
  
  */
  
}


//ROACH CLASS
class roach {
  // some variables
  float posX, posY;
  float dy,dx,delta;
  float mx,my;
  float angle;
  PImage roachPic = loadImage("roach.gif");
  PImage roachPic_a = loadImage("roach_alpha.gif");
  PImage roachPic_b = loadImage("roach_b.gif");
  PImage roachPic_g = loadImage("roach_g.gif");
  boolean isActive = false;
  boolean isHiding = false;
  int special;
  float roachTimer;

  //CONSTRUCTOR
  roach() {

    //choose if it will spawn under spoon or tea bag
    int randPos = PApplet.toInt(random(0,2));
    if (randPos == 0) {
      posX = 400;
      posY = 150;
    } else {
      posX = 10;
      posY = 320;
    }

    //start the counter
    roachTimer = millis() + timerVar;

  }

  void moveRoach(float randomDist) {

    //distance between mouse and roach
    dx = mouseX - posX;
    dy = mouseY - posY;
    delta = sqrt(dx*dx + dy*dy);

    //if the mouse is close to the roach
    if(delta < randomDist){

      // change the position
      posX = posX - (dx/moveSpeed);
      posY = posY - (dy/(moveSpeed+1));

      //change the rotation
      angle = atan2(dy,dx);
    } 
    

    // Keep it from running off the stage
    if(posX < 10) {
      posX = random(15,25);
    } else if(posX > 390) {
      posX = random(375,385);
    }

    if(posY < 10) {
      posY = random(15,25);
    } else if(posY > 365) {
      posY = random(350,360);
    }
    
    if((posX > 357 && posY > 139 && posY < 200) ||
        (posX < 25 && posY > 303 && posY < 339)) {
       isHiding = true;   
    } else {
      isHiding = false;
    }

  }

  void drawRoach() {

    push();
    //translate position and rotation
    translate(posX,posY);
    rotate(angle - radians(90));

    //draw the roach
    if (special == 0) {
      alpha(roachPic,roachPic_a);
      image(roachPic,0,0);
    } else if (special == 1) {
      alpha(roachPic_g,roachPic_a);
      image(roachPic_g,0,0);
    } else if (special == 2) {
      alpha(roachPic_b,roachPic_a);
      image(roachPic_b,0,0);
    }

    //draw the roach's counter
    fill(255,255);
    textFont(knockout, 8);
    textMode(ALIGN_CENTER);
    text(PApplet.toInt(((roachTimer-millis())/1000)/2)+ 1, 1, 1);
    pop();

    // if the roach times out reset it
    if(roachTimer < millis() && isActive) {
      roachTimer = millis() + timerVar;
      special = 0;

      //BREED!!
      warningTimer = millis() + 400;
      breeding = true;

      //INFESTATION!!
      if(MIN > (MAX - 5)) {
        infestation = true;
      }

      if(!infestation) {
        myRoaches[MIN].isActive = true;
        myRoaches[MIN].roachTimer = millis() + timerVar;
        MIN++;
      }

    }
  }

  boolean isOver(float x, float y) {      //is the mouse over the roach?

    if(mouseX > (x-15) && mouseX < (x+15) &&
    mouseY > (y-15) && mouseY < (y+15) && sprayCanActive ==false) {
      return(true);

      //if the spray can is active is the mouse near the roach?
    } else  if(mouseX > (x-25) && mouseX < (x+25) &&
    mouseY > (y-25) && mouseY < (y+25) && sprayCanActive == true){
      return(true);
    } else {
      return(false);
    }
  }

} // ! end roach class !



//Bomb Class
class bomb {
  float bombX, bombY;
  float bombTimer;
  boolean bombSet;
  int drawExplosion;

  //CONSTRUCTOR
  bomb() {
    bombSet = false;
    drawExplosion = 5;
  }

  void updateBomb() {
    if(bombTimer < millis() && bombSet) {
      // if the timer is up AND the bomb has been placed
      // blow it up!
      bombExplode(bombX, bombY);
    }
  }

  void displayBomb() {
    
    //if the bomb has been placed
    if (bombSet){
      //draw the bomb
      alpha(bombset, bombset_a);
      image(bombset, bombX, bombY);

      //draw the bomb counter
      textFont(knockout, 12);
      fill(255,255);
      text(PApplet.toInt((bombTimer-millis())/1000) + 1, bombX+1, bombY+5);
    }

    // if the bomb is currently exploding
    if (drawExplosion < 5) {
    
      //draw the explosion
      //this runs 5 times to give some temporal
      //dimensionality to the explosion
      fill(255, 50);
      for(int i = 0; i < 10; i++) {
        float rx = random(bombX - 100, bombX+100);
        float ry = random(bombY - 100, bombY+100);
        ellipse(rx,ry, 25,25);
        ellipse(rx,ry, 15,15);
        ellipse(bombX,bombY, 20*i,20*i);
      }
      drawExplosion++;
    }

  }

  void setBomb(float x, float y) {
    bombX = x;
    bombY = y;
    bombSet = true;
    bombTimer = millis() + 3000;
    bombingActive = false;
    bombCounter++;

    if(bombCounter > 29) {
      bombCounter = 0;
    }
  }

  void bombExplode(float bombX, float bombY) {
    bombSet = false;
    drawExplosion = 0;

    //cycle through roaches array
    //if they're within range, kill them
    for(int i = 0; i < MIN; i++) {
      if(myRoaches[i].posX > (bombX - 100) && myRoaches[i].posX < (bombX + 100) &&
      myRoaches[i].posY > (bombY - 100) && myRoaches[i].posY < (bombY + 100)
      && !myRoaches[i].isHiding) {
        poison(i);
      }
    }
  }

} // ! end bomb class !
}